/* 
This work is licensed by the Creative Commons
Attribution-NonCommercial-ShareAlike 1.0

Key License Terms:
Attribution. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees must give the original author credit.

Noncommercial. The licensor permits others to copy, distribute, display, and perform the work. In return, licensees may not use the work for commercial purposes -- unless they get the licensor's permission.

Share Alike. The licensor permits others to distribute derivative works under a license identical to the one that governs the licensor's work.

http://creativecommons.org/licenses/by-nc-sa/1.0

Visit http://www.blozom.com for commercial licensing terms.  
Copyright 2003, Uzilla LLC
*/

var blozomFileExtension, blozomPublishPath, blozomDataPath, blozomWebRoot, blozomCategoriesFolder, blozomCategoryXML, rssMaxFeedItems, blozomRssCategories;

// Temporary hack to populate view notes menu item
var blozomNotesFolders = new Array(1);

var platform = new String(navigator.platform);
dump("Platform is " + platform + "\n");
if(platform.search(/^Win/)) {
	var blozomFileSeparator = "/";
} else {
	var blozomFileSeparator = "\\";
}
dump("\n%%%%%% Platform is "  + " with " + blozomFileSeparator +  "\n");



var blozomEditModes = new Array(1);
blozomEditModes[0] = "blog";
blozomEditModes[1] = "note";

var curDate, curMonth, curDay, curYear;

	curDate = new Date();
	curMonth = curDate.getMonth()+1;
	curMonth = curMonth + '';
	if(curMonth.length == 1) curMonth = '0' + curMonth;
	//dump("\n\n---->Cur month length is " + curMonth.length + "\n");
	curDay = curDate.getDate() + '';
	if(curDay.length == 1) curDay = '0' + curDay;
	curYear = curDate.getFullYear();

	
	
var maxFileOffset = 0;

var stubTreeChild = document.createElement("treechildren");
var categoryDoc = false;

function triggerRepositorySwitch() {
	var repNode = 	document.getElementById("blozom-repository").getElementsByAttribute("selected", true).item(0);
	if(repNode.getAttribute("label") != lastRepository) {
	// Trim Directory Tree
	var fileHolder = document.getElementById("blozom-tree-root");
	dump("file holder is " + fileHolder.nodeName + " " + fileHolder.childNodes.length + "\n");
	for(var i=fileHolder.childNodes.length-1;i >= 0;i--) {
		fileHolder.removeChild(fileHolder.childNodes.item(i));
		dump("trimmed a file \n");
	}
	// Clear ui categories
    var categoryHolder =document.getElementById("blozom-categories");
	for(var j=categoryHolder.childNodes.length-1; j>=0;j--) {
		dump("trimmed a cat \n");
		categoryHolder.removeChild(categoryHolder.childNodes.item(j));
	}
	clearBlogForm();
	//blozomInitPublish();
	loadRepository(repNode.getAttribute("label"), true);
	}
}

// TODO: Walk Repository Object for default
// why dontRebuild flag

// Returns default if repository is false
function findDefaultRepository() {
	for(var i in blozomPrefs) {
		dump("Default repository found at " + blozomPrefs[i].defaultBlog + " at " + i + "\n");
		if(blozomPrefs[i].defaultBlog) return i;
	}
	return false;
}

function selectRepository(key) {
	dump("Setting repository menu to " + key + "\n");
	var repositoryMenu = document.getElementById("blozom-repository").childNodes.item(0);
	for(var i=0; i<repositoryMenu.childNodes.length;i++) {
		dump("at " + repositoryMenu.childNodes.item(i).getAttribute("label") + " of " + repositoryMenu.childNodes.item(i).nodeName + "\n");
		if(repositoryMenu.childNodes.item(i).getAttribute("label") == key) {
			document.getElementById("blozom-repository").selectedIndex = i;
			return true;
		}
	}
	return false;
}

function loadRepository(repositoryKey, dontRebuild) {
	throbberBusy();
	dump("\n&&&Loading repository " + repositoryKey + " \n");
	var repositoryPopup = document.getElementById("blozom-repository-popup");
	var repository;
	var tempNode;
	
	if(repositoryKey == false) {
		 repositoryKey = findDefaultRepository();
		 
	}
	// Hack to deal with onload firing 3 times when launched
	// from an existing mozilla instance, but only once from bat file
	if(lastRepository != repositoryKey) {
	for(var i in blozomPrefs) {
		var  repository = blozomPrefs[i];	
		if(!dontRebuild) {
			tempNode = document.createElement("menuitem");
			tempNode.setAttribute("label", i);
			repositoryPopup.appendChild(tempNode);
		}
		
		if(repositoryKey == i) {
			dump("Choosing " + i + " repository \n");
			window.title = "Blozom: " + i + " Space";
			blozomDataPath = repository.blozomDataPath;
			blozomPublishPath = repository.blozomPublishPath;
			blozomFileExtension = repository.blozomFileExtension;
			blozomWebRoot = repository.blozomWebRoot;
			blozomRemotePath = repository.remotePath;
			blozomAuthorName = repository.authorName;
			blozomSiteName = repository.siteName;
			
			rssMaxFeedItems = repository.rssMaxFeedItems;
			blozomCategoriesFolder = repository.blozomCategoriesFolder;
			blozomRssCategories = repository.blozomRssCategories;
			blozomCategoryXML = repository.blozomCategoryXML;
			blozomRssStarter = repository.rssStarter;
			rssXMLdoc = new DOMParser().parseFromString(blozomRssStarter, "text/xml");

			if(!dontRebuild) {
				//tempNode.setAttribute("selected", true);
				repositoryPopup.selectedItem = i;
			}
		}
	}
	repositoryInit();
	initMapObject();
	throbberIdle();
	var root = new Dir(blozomDataPath);
	selectRepository(repositoryKey);
	blozomMasterMap(root, blozomDataPath);
	blozomPopulateNotesViewMenu();
	lastRepository = repositoryKey;
	}
}

function deleteAllChilds(node) {
	if(node) {
	for(var i=node.childNodes.length -1; i>=0;i=i-1) {
		node.removeChild(node.childNodes.item(i));
	}
	}
}


function blozomPopulateNotesViewMenu() {
	// NO notes view for the sidebar right now, v0.1.1
	if(document.getElementById("blozom-notes-view-holder")) {
	var myOnCommand;
	dump("\n&&&& Popping notes view with " + blozomNotesFolders.length + "\n");
	deleteAllChilds(document.getElementById("blozom-notes-view-holder"));
	var tempNode;
	for(var i=0;i<blozomNotesFolders.length;i++) {
		
		//dump("appending note menu node " + blozomNotesFolders[i] + " " + listLen(blozomNotesFolders[i], "\\") + "  \n\n");
		//if(listLen(blozomNotesFolders[i], "\\") > 2) {
		tempNode = document.createElement("menuitem");
		tempNode.setAttribute("label", blozomNotesFolders[i]);

		tempNode.setAttribute("oncommand", "invokeNotesView(event)");	document.getElementById("blozom-notes-view-holder").appendChild(tempNode);
		//}
	}
		/*blozom" oncommand="window.open('chrome:';//blozom/content/noteview/index.xul?path=";
,'','toolbar=no,top=500,width=300,height=400,resizable=yes');\"/>' */
}
}

function invokeNotesView(event) {
		var path = 'chrome://blozom/content/noteview/index.xul?path=' + event.target.label;
		window.open(path, '', 'toolbar=no,top=500,width=300,height=400,resizable=yes');
}
		
function repositoryInit() {
	//dump("\n\nIniting repository \n");
	myDirPath = blozomDataPath;
	//dump("mydir is " + myDirPath + "\n");
	myDir = new Dir(myDirPath);
	categoryDoc = new DOMParser().parseFromString(blozomCategoryXML, "text/xml");
	initCategories();
	//ump("directory  " + myDir + " exists " + myDir.exists() + "\n")
	myDirArray = myDir.readDir();
	//dump("Looping over " + myDirArray.length + " dir elements \n");
	for(i in myDirArray) {
		//dump("Looking at " + i + " at " + myDirArray[i].path + " of type " + myDirArray[i].isDir() + "\n");
		if(myDirArray[i].isDir()) {
			//dump("adding a directory\n")
			 addDirectory(document.getElementById("blozom-tree-root"), myDirArray[i],i);
		}
		else {
			if(myDirArray[i].isFile()) {
				//dump("adding a file\n");
				addFile(document.getElementById("blozom-tree-root"),myDirArray[i],i);
			}
		}
	}
	maxFileOffset = i;
	document.getElementById("blozom-tree-root").addEventListener("click", getTreeCell, true);
	blozomGetTodaysPosts();
}

function initCategories() {
	var categoryHolder =document.getElementById("blozom-categories");
	var tempNode;
	dump(categoryDoc.childNodes.length + " categories\n");
	dump(categoryDoc.childNodes.item(0).nodeName + " is child node name\n");
	dump(categoryDoc.childNodes.item(0).childNodes.item(0).nodeName + " child child \n");
	var categoryRoot = categoryDoc.childNodes.item(0);
	dump("category root is " + categoryRoot.nodeName + "\n");
	for(var i=0;i<categoryRoot.childNodes.length;i++){

	tempNode = document.createElement("checkbox");
	tempNode.setAttribute("label",  categoryRoot.childNodes.item(i).childNodes.item(0).nodeValue );
	tempNode.setAttribute("id",  "blozom-category-" + categoryRoot.childNodes.item(i).childNodes.item(0).nodeValue );
	tempNode.setAttribute("onclick", "document.getElementById('blozom-editor-save').disabled=false;");
	categoryHolder.appendChild(tempNode);
	}
}

function prettifyPath(path) {
	var arPath = path.split(blozomFileSeparator);
	return arPath[arPath.length -1 ];
}

function addDirectory(root, dirObj, offset) {
	dump("Adding directory " + dirObj+ " to root " + root.nodeName + "\n");
	var myTreeItem = document.createElement("treeitem");
	var myTreeRow = document.createElement("treerow");
	var myNode = document.createElement("treecell");
	myNode.setAttribute("label", prettifyPath(dirObj.path));
	myTreeItem.setAttribute("container", true);
	myTreeItem.setAttribute("parent", true);
	myTreeItem.setAttribute("loaded", false);
	myNode.setAttribute("path", dirObj.path);
	dump("Setting path to " + dirObj.path + "\n");
	myNode.setAttribute("open",false);
	myNode.setAttribute("id", "d" + offset) 
	myNode.setAttribute("kind", "directory");
	//myTreeItem.addEventListener("click", populateSubDirectory, false);
	

	myTreeRow.appendChild(myNode);
	myTreeItem.appendChild(myTreeRow);
	// Placeholder for up and coming branches
	myTreeItem.appendChild(document.createElement("treechildren"));
	var newNode = root.appendChild(myTreeItem);
	dump("Got new node " + newNode.childNodes.item(0).childNodes.item(0).nodeName +  "\n");
	//dump("Event listener created " + newNode.addEventListener("click", populateSubDirectory, false) + "\n");
	//dump("Event listener created " + document.getElementById("d" + offset).addEventListener("click", populateSubDirectory, false) + "\n");

	//document.getElementById("d" + offset).addEventListener("moudedown", populateSubDirectory, false);

}

function addFile(root,fileObj,offset) {
	dump("Adding directory " + fileObj+ "\n");
	var myTreeItem = document.createElement("treeitem");
	var myTreeRow = document.createElement("treerow");

	var myNode = document.createElement("treecell");
	myNode.setAttribute("label", prettifyPath(fileObj.path));
	myNode.setAttribute("path", fileObj.path);
	myNode.setAttribute("kind", "file");
	
	myNode.setAttribute("id", "f" + offset) 
	myTreeRow.appendChild(myNode);
	myTreeItem.appendChild(myTreeRow);
	root.appendChild(myTreeItem);
	//myTreeItem.addEventListener("click", editFile, false);
	//document.getElementById("f" + offset).addEventListener("click", editFile, false);
}

function populateSubDirectory(root, myDir) {
	dump("populate called with " + root + " " + myDir + "\n");
	if(root.getAttribute("loaded")) {
		return false;
	} else {
		root.setAttribute("loaded", true);
	}
	dump("\n\nPopulating subdirectory " + root.nodeName + "\n");
//	dump("mydir is " + path + "\n");
//	myDir = new Dir(path);
	dump("directory exists " + myDir.exists() + "\n")
	dump("got dir " + myDir + "\n");
	dump("my dir is " + myDir + " " + myDir.length + "\n");
	myDirArray = myDir.readDir();
	for(i in myDirArray) {
		dump("Looking at " + i + " at " + myDirArray[i].path + "\n");
		maxFileOffset++;
		if(myDirArray[i].isDir()) {
			dump("adding a directory\n");
			 addDirectory( root, myDirArray[i],maxFileOffset+1);
		}
		else {
			if(myDirArray[i].isFile()) {
			dump("adding a file\n")
				addFile( root,myDirArray[i],maxFileOffset+1);
			}
		}
	}
}

/* bogus 
function editFile(evt) {
	var path = evt.target.getAttribute("path");
	var offset = evt.target.getAttribute("id");
	dump("\n\nEditing File " + path + "\n");
	var myFile = new File(path);
	myFile.open();
	dump("File is " + myFile.read() + "\n");
}
*/
function getTreeCell(event)
{
	//dump("\n\nevent orig target is " + event.target.nodeName + " " + event.target.nodeName + "\n");
//	dump("has child " + event.target.childNodes.length + " " + event.target.childNodes.item(i).nodeName + " with parent " + event.target.parentNode.nodeName + "\n");
	
	//var myTreeItem = new Object();
	var viewOjb = new Object();
	dump("Got tree event \n");
        //get original target (element user clicked on)
        var str_OrigTarget = event.originalTarget;

        //if target is a treechildren, we're right
        if (str_OrigTarget.localName == "treechildren")
        {
                //create storage containers for results values
                var obj_Row     = new Object;
                var obj_Col     = new Object;
                var obj_Child   = new Object;

                //find tree holder
                var obj_Tree    = document.getElementById('blozom-file-tree');

                //get cell at x/y coords from tree
                obj_Tree.treeBoxObject.getCellAt(event.clientX, event.clientY, obj_Row, obj_Col, viewOjb);

                //if row < 0, we didn't find the row selected in this tree
                if (obj_Row.value == -1) return;
        }

        //do something with the column name and row value found
        //doSomething(obj_Row.value,obj_Col.value);
		dump("found " + obj_Row.value + obj_Col.value + " at " + i + "\n");
		//	var myTreeItem = child_at(document.getElementById("blozom-tree-root"), obj_Row.value);
		//for(i in myTreeItem) dump(" obj is " + i +  " " + myTreeItem[i] + "\n"); **returns twisty**
		var myTreeItem = obj_Tree.contentView.getItemAtIndex(obj_Row.value);
		//var myTreeItem = event.target.childNodes.item(obj_Row.value);
		//for(i in obj_Col) dump("col obj is " + i +  " " + obj_Col[i] + "\n"); 
		
	//	var outlinerBuilder = outliner.builder.QueryInterface(Components.interfaces.nsIXULOutlinerBuilder);

		//var resource = outlinerBuilder.getResourceAtIndex(index);

		dump("Tree Item is " + myTreeItem + " of type " + myTreeItem.nodeName + "\n");
		var myTreeRow = first_child(myTreeItem);
		dump("got row of " + myTreeRow.nodeName + "\n")
		var myTreeCell = first_child(myTreeRow);
		dump("got cell " + myTreeCell.nodeName + "\n");
dump("At tree cell of type" + myTreeCell.getAttribute("kind")+ " with label " + myTreeCell.getAttribute("label") + myTreeCell.getAttribute("path") + "\n");
		if(myTreeCell.getAttribute("kind") == "directory") {
			var folderPath = myTreeCell.getAttribute("path");
			dump("Toggle folder " + folderPath + "\n");
			var dirObj = new Dir(folderPath);
			var newRoot = myTreeItem.childNodes.item(1);
			dump("Populating to " + newRoot.nodeName + " (should be treechildren) \n");
			populateSubDirectory(newRoot, dirObj, maxFileOffset+1);
			//expandFolder(folderPath, myTreeCell.getAttribute("id"));
		} else {
			if(myTreeCell.getAttribute("kind") == "file") {
				dump("Edit file\n");
				editFile(myTreeCell.getAttribute("path"));
			}
		}
		
}



function massagePath(strPath) {
	var arFilePath = strPath.split(blozomFileSeparator);
	//dump("Found " + arFilePath.length + " path components \n");
	var filePath = '';
	for(var i=0;i<(arFilePath.length -1);i++) {
		//dump("Adding component " + arFilePath[i] + "\n");
		filePath += arFilePath[i] +blozomFileSeparator; // "\\\\";
		//dump("cur file path is " + filePath + "\n");
	}
	filePath += arFilePath[i];
	return filePath;
}

function blozomLoadFromBar() {
	blozomInsurePath(blozomDataPath + blozomFileSeparator + document.getElementById("blozom-bar").value);
	editFile(blozomDataPath + blozomFileSeparator +document.getElementById("blozom-bar").value);
}

function editFile(myFile) {
	clearBlogForm();
	//dump("Editing " + myFile + " vs " + myFile.replace("\\","\\\\") + "\n");
	
	var filePath = massagePath(myFile);
	//dump("File path hacked is " + filePath +"\n");
	var fileObj = new File(filePath);
	fileObj.open("r",0744);
	var postContent = fileObj.read();
	dump("File is " + fileObj.exists() + " " + content + "\n");
	//document.getElementById("blozom-post").value = postContent;
	document.getElementById('edit-box').contentWindow.document.body.innerHTML = postContent;
	document.getElementById("blozom-editor-save").disabled = true;
	document.getElementById("blozom-bar").value = normalizePath(filePath.replace(blozomDataPath, ""));

	if(blozomIsBlogFolder(filePath)) {
		document.getElementById("blozom-edit-mode-deck").selectedIndex=0;
		dump("Blog post\n");
		var wikiName = listLast(filePath);
		var wikiName = wikiName.replace(".txt","");
		//dump("Making xml doc out of " + postContent + "\n");
		//dump("\n\n ----\n-----" + xmlDoc.getElementById("postTitle") + " is blog post title \n");
		document.getElementById("blozom-wiki-name").value = wikiName;
		document.getElementById("blozom-wiki-name").readonly = true;
		readMetaData(filePath);
		

	} else {
		document.getElementById("blozom-edit-mode-deck").selectedIndex=1;
	}
}

var xmlDoc;
function readMetaData(filePath) {
		
		var tempFile = new File(filePath.replace(".txt", ".xml"));
		dump("[LOAD-FILE] Looking for metadata file " + tempFile.exists() + "\n");
		if(tempFile.exists()) {
			tempFile.open("r",0644);
			var xmlContent = tempFile.read();
			dump("XML is " + xmlContent + "\n");
			var metaData = new DOMParser().parseFromString(xmlContent, "text/xml");
			processMetaData(metaData); //Populat edit widget
			//xmlDoc= document.implementation.createDocument("","doc",null);
			dump("Got xmldoc \n");
			//var xmlPath = filePath.replace(".txt", ".xml");
			//var xmlPath = listLast(xmlPath);
			//dump("new File is " + xmlPath+"\n");
			//xmlDoc.onload = processMetaData();
			//xmlDoc.load(xmlPath);

		}
}  

// This is not generic. Populates edit widget;
function processMetaData(metaData) {	
	//dump("Metadata for " + metaData.childNodes.item(0).childNodes.item(0).childNodes.item(0).childNodes.item(0).data + " " + metaData.childNodes.item(0).childNodes.item(0).childNodes.item(0).nodeValue + " " + metaData.childNodes.item(0).childNodes.item(0).nodeName + "\n");
	var title = metaData.childNodes.item(0).childNodes.item(0).childNodes.item(0).childNodes.item(0).data ;//childNodes.item(0)
	document.getElementById("blozom-title").value = xmlUnescape(title);
	var item = metaData.childNodes.item(0).childNodes.item(0)
	//dump("item value is " + item + " " + item.value + " " + item.nodeValue + "\n");
	//dump("val is " + item.value + "\n");
	//dump("nodenamed item is " + item.nodeName + "\n");
	//dump("nodeval item is " + item.nodeValue+ "\n");
	
	//for(i in item) dump(i + " " + item[i] + "\n");
	dump("Found meta data " + metaData + " \n");
	dump(" childs " + metaData.childNodes.length + "\n");

	/*var categories = metaData.getElementsByTagName("category");
	dump(" item() returns " + categories.item(1) + "\n");
	*/
	dump("&& Looking for categories at " + item.nodeName + " " + item.childNodes.length + " childs \n");
	var tempCatNodeID;
	var tempDate
	for(var i=0;i< item.childNodes.length;i++) {

		dump(item.childNodes.item(i).nodeName + "\n");
		if(item.childNodes.item(i).nodeName == "category") {
			tempCatNodeId ="blozom-category-" +  item.childNodes.item(i).childNodes.item(0).nodeValue;
			//dump("\nTTTTTurning on a category checkbox " + tempCatNodeId + "\n");
		 	document.getElementById(tempCatNodeId).checked = true;
		}
		
		// TODO Remove hack to fix busted ?
		
		if(item.childNodes.item(i).nodeName == "pubdate") {
		dump("\n\n processing date " + item.childNodes.item(i).childNodes.item(0).nodeValue + "\n");
			if( item.childNodes.item(i).childNodes.item(0).nodeValue.indexOf("Invalid") > -1) {
				dump("Fixoring date \n");
				tempDate = new Date().getTime();
				document.getElementById("blozom-pub-date").value = tempDate.toGMTString();
			}  else {
	
			//dump("Year is " + tempDate.getYear() + " " + tempDate.toGMTString() + "\n");
			document.getElementById("blozom-pub-date").value = item.childNodes.item(i).childNodes.item(0).nodeValue;
			}
		}
	}
	
	//document.getElementById("blozom-title").value = metaData.childNodes.item(0).childNodes.item(0).value;
	
}

function makePostFolder(day,month,year) {
	var myDirPath = blozomDataPath + blozomFileSeparator + year;
	var myDir = new Dir(myDirPath);
	dump("Creating Blog Post " + day + " " + month + " " + year + "\n");
	dump("Year directory "  + myDir  + " exists " + myDir.exists() + "\n");
	if(!myDir.exists()) {
		// Create year directory
		dump("Creating Year Directory for " + year +  " at " + myDirPath + "\n");
		myDir.create(0644);
	}
	if(month.length < 2) month = 0 + '' + month;
	myDirPath = myDirPath + blozomFileSeparator + month;
	
	var myDir = new Dir(myDirPath);
	dump("Month directory " + month + " "  + myDir  + " exists " + myDir.exists() + "\n");
	if(!myDir.exists()) {
		// Create month directory
		dump("Creating Month Directory for" + month +   " at " + myDirPath + "\n");
		myDir.create(0644);
	}
	if(day.length < 2) day = 0 + '' + day;
	myDirPath = myDirPath + blozomFileSeparator  + day;
	dump("Day directory "  + myDir  + " exists " + myDir.exists() +  " at " + myDirPath + "\n");
	var myDir = new Dir(myDirPath);
		if(!myDir.exists()) {
		// Create day directory
		dump("Creating Day Directory " + day + "\n");
		myDir.create(0644);
	}
	
	dump("Writing file to " + myDirPath + "\n");
	var myFile = new File(myDirPath + blozomFileSeparator + 'index.txt');
	writeFile(myFile);
	document.getElementById("blozom-bar").value = myDirPath.replace(blozomDataPath, "");
	
}

function writeFile(myFile) {
	if(myFile.exists()) {
		dump("File exists!\n");
	}
	 myFile.open('w',0644);
	 //myFile.write(document.getElementById("blozom-post").value);
	 myFile.write( document.getElementById('edit-box').contentWindow.document.body.innerHTML);
	 myFile.close();
	 document.getElementById("blozom-editor-save").disabled = true;
}
function doBar() {
	var bar = document.getElementById("blozom-bar");
	var barValue = bar.value;
	editFile(blozomDataPath + blozomFileSeparator +barValue);
}

function throbberBusy() {
	document.getElementById("blozom-throbber").src = "chrome://blozom/content/skin/throbber_on.png";
}

function throbberIdle() {
	document.getElementById("blozom-throbber").src = "chrome://blozom/content/skin/throbber_off.png";
}